/***************************************************************************
*
*	File name : extflsc_api.h
*	Function  : External flash control driver (C17801)
*	Revision  :
*		September. 26, 2007	Yakushiji		First revision
*
****************************************************************************/

#ifndef	___EXTFLSC_API_H___
#define	___EXTFLSC_API_H___

typedef struct {
	unsigned long		control;		// Control register address
} T_EXTFLSC_CFG;


#define	EXTFLSC_ERASE_CHIP		0x10
#define	EXTFLSC_ERASE_SECTOR	0x30

#define	EXTFLSC_TOP_ADDRESS		0x100000
#define	EXTFLSC_END_ADDRESS		0x8FFFFF

#define	EXTFLSC_SMALL_SEC		0x2000
#define	EXTFLSC_LARGE_SEC		0x10000

// Address definition
#define	EXTFLSC_COM1_ADDR		(0x555 << 1)	// Address for flash command1
#define	EXTFLSC_COM2_ADDR		(0x2aa << 1)	// Address for flash command2

// Command definition
#define	EXTFLSC_ERASE1			0xaa			// Flash erase command1
#define	EXTFLSC_ERASE2			0x55			// Flash erase command2
#define	EXTFLSC_ERASE3			0x80			// Flash erase command3
#define	EXTFLSC_ERASE4			0xaa			// Flash erase command4
#define	EXTFLSC_ERASE5			0x55			// Flash erase command5

#define	EXTFLSC_PROG1			0xaa			// Flash byte program command1
#define	EXTFLSC_PROG2			0x55			// Flash byte program command2
#define	EXTFLSC_PROG3			0xa0			// Flash byte program command3

#define	EXTFLSC_RESET			0xf0			// Flash reset command

#define	EXTFLSC_B_DQ6			0x0040			// Toggle Bit

#ifdef __cplusplus
extern "C" {
#endif

extern void		ExtFlscInit(T_EXTFLSC_CFG *);
extern int		ExtFlscErase(unsigned char, unsigned long, unsigned long);
extern int		ExtFlscWrite(unsigned long, unsigned long, unsigned short*);

#ifdef __cplusplus
}
#endif

#endif	/* __EXTFLSC_API_H__	*/

