/***************************************************************************
*
*	File name : inthdlr.c
*	Function  : Interrupt Handler (C17801)
*	Revision  :
*		07/31/2007	Nariai		First revision
*
****************************************************************************/


// Include File
#include	"reg_801.h"

// Prototype
void AddrErrInt(void)	__attribute__ ((interrupt_handler));
void NmiInt(void)		__attribute__ ((interrupt_handler));
void RsvInt(void)		__attribute__ ((interrupt_handler));
void UsbInt(void)		__attribute__ ((interrupt_handler));


/***************************************************************************
	AddrErrInt

	description	: Interrupt handler for "Address misaligned"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void AddrErrInt(void){

	asm("brk");

}


/***************************************************************************
	NmiInt

	description	: Interrupt handler for "NMI"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void NmiInt(void){

	asm("brk");

}


/***************************************************************************
	RsvInt

	description	: Interrupt handler for "Reserved"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void RsvInt(void){

	asm("brk");

}

/***************************************************************************
	UsbInt

	description	: Interrupt handler for "USB"
	argument	: None
	return: 	: None

	input		:
	output		:

	flag		: None
	global		: None
***************************************************************************/
void UsbInt(void){

	UsbInterruptHandler();

	// Clear interrupt factor
	ITC_AITFT		= ITC_AITFT_AIFT11;

//	asm("brk");

}

