/***************************************************************************
*
*	File name : usb_control.h
*	Function  : USB driver (C17801)
*			Transfer or Receive control for Control pipe.
*	Revision  :
*		August. 20, 2007	Yakushiji		First revision
*
****************************************************************************/

#ifndef	__USB_CONTROL_H__
#define	__USB_CONTROL_H__

// Control pipe state
#define EP0_REQ_CHECK			(0x00)
#define EP0_DATA_SET			(0x01)
#define EP0_DATA_SEND			(0x02)
#define EP0_DATA_RCV			(0x03)
#define EP0_DATA_GET			(0x04)
#define EP0_STS_START			(0x05)
#define EP0_STS_END				(0x06)
#define EP0_IDLE				(0x07)

// g_EP0Result
#define	EP0_NO_RESULT			(0x00)
#define	DESCRIPTOR_CMP			(0x01)
#define	EP0_IN_ERR				(0x02)
#define	EP0_OUT_ERR				(0x03)
#define	EP0_IN_ACK				(0x04)
#define	EP0_OUT_ACK				(0x05)

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned char			g_EP0State;			// Endpoint0 state
extern unsigned char			g_EP0Result;		// Endpoint0 result
extern T_USB_REQUEST_PACKET		g_RequestPacket;	// Request packet

#ifdef __cplusplus
}
#endif


#endif	// __USB_CONTROL_H__
