/***************************************************************************
*
*	File name : descriptor.c
*	Function  : USB Mass Storage Bulk Ony Descriotor (C17801)
*	Revision  :
*		August. 20, 2007	Yakushiji		First revision
*
****************************************************************************/

#include	"descriptor.h"

// Descriptor for Bulk Only Mass Storage Class
const unsigned char	DescriptorData[] = {
	// Device Descriptor
	0x12,			// bLength
	0x01,			// bDescriptorType
	0x10,0x01,		// bcdUSB
	0x00,			// bDeviceClass
	0x00,			// bDeviceSubClass
	0x00,			// bDeviceProtocol
	0x40,			// bMaxPacketSize0
	0xB8,0x04,		// idVendor
	0x09,0x05,		// idProduct
	0x00,0x01,		// bcdDevice
	0x01,			// iManufacturer
	0x02,			// iProduct
	0x03,			// iSerialNumber
	USB_CONFIG_NUM,	// bNumConfigurations

	// Config Descriptor
	0x09,			// bLength
	0x02,			// bDescriptorType
	0x12,0x00,		// wTotalLength
	0x01,			// bNumInterfaces
	0x01,			// bConfigurationValue
	0x00,			// iConfiguration
	0xC0,			// bmAttributes
	0xF0,			// bMaxPower

	// Interface Descriptor
	0x09,			// bLength
	0x04,			// bDescriptorType
	0x00,			// bInterfaceNumber
	0x00,			// bAlternateSetting
	0x00,			// bNumEndpoints
	0xFF,			// bInterfaceClass(BulkOnly)
	0xFF,			// bInterfaceSubClass
	0xFF,			// bInterfaceProtocol
	0x00,			// iInterface

	// String Descriptor Index0
	0x04,			// bLength
	0x03,			// bDescriptorType
	0x09,			// LANGID
	0x04,

	// String Descriptor Index1
	0x12,			// bLength
	0x03,			// bDescriptorType
	'E',0x00,		// bString
	'P',0x00,
	'S',0x00,
	'O',0x00,
	'N',0x00,
	' ',0x00,
	' ',0x00,
	' ',0x00,

	// String Descriptor Index2
	0x26,			// bLength
	0x03,			// bDescriptorType
	'E',0x00,		// bString
	'P',0x00,
	'S',0x00,
	'O',0x00,
	'N',0x00,
	' ',0x00,
	'U',0x00,
	'S',0x00,
	'B',0x00,
	' ',0x00,
	'R',0x00,
	'E',0x00,
	'W',0x00,
	'R',0x00,
	'I',0x00,
	'T',0x00,
	'E',0x00,
	'R',0x00,

	// String Descriptor Index3
	0x12,			// bLength
	0x03,			// bDescriptorType
	'R',0x00,		// bString
	'e',0x00,
	'v',0x00,
	'.',0x00,
	'0',0x00,
	'.',0x00,
	'0',0x00,
	'1',0x00
};

const unsigned short	DescriptorSize = sizeof(DescriptorData);
