# Make file generated by Gnu17 Plug-in for Eclipse
# This file should be placed directly under the project folder

# macro definitions for target file
TARGET= usb_rewriter

# macro definitions for tools
TOOL_DIR= C:/EPSON/GNU17
CC= $(TOOL_DIR)/xgcc
AS= $(TOOL_DIR)/xgcc
AS_CC= $(TOOL_DIR)/as
LD= $(TOOL_DIR)/ld
RM= $(TOOL_DIR)/rm
SED= $(TOOL_DIR)/sed
CP= $(TOOL_DIR)/cp
CC_KFILT= $(TOOL_DIR)/xgcc_filt
OBJDUMP= $(TOOL_DIR)/objdump

# macro definitions for tool flags
CFLAGS= -B$(TOOL_DIR)/ -gstabs -S   -O1 -I$(TOOL_DIR)/include -I. -Iheader -Iflashc_drv -Iextflsc_drv -Iusb_drv -DFLASHC_MINIMUM_API -DFOR_FLASH_128 -D_FOR_FLASHC_MINIMUM_API -D_FOR_CLEAR_FEATURE -D_FOR_SET_FEATURE -D_FOR_GET_INTERFACE -D_FOR_SET_INTERFACE -D_FOR_CLASS_REQUEST -D_FOR_TEST_MODE -D_FOR_BULK_TRANSFER -D_FOR_NEGOTIATION -D_FOR_ADDRESS -D_FOR_MANAGEMENT -D_FOR_REMOTEWAKEUP -DFOR_SNOOZE_OFF -DFOR_USB_MINIMUM_API -fno-builtin 
ASFLAGS= -B$(TOOL_DIR)/ -c -xassembler-with-cpp -Wa,--gstabs  
ASFLAGS_CC=  
LDFLAGS=  -Map usb_rewriter.map -N -T usb_rewriter_gnu17IDE.lds  
EXTFLAGS= -Wa,-mc17_ext -Wa,$(TARGET).dump -Wa,$(TARGET).map
EXTFLAGS_CC= -mc17_ext $(TARGET).dump $(TARGET).map
OBJDUMPFLAGS= -t


# macro definitions for object files
OBJS= boot.o \
      classrequest.o \
      descriptor.o \
      inthdlr.o \
      main.o \
      vector.o \
      vendorclass.o \
      extflsc_drv/extflsc_drv.o \
      flashc_drv/flashc_drv.o \
      usb_drv/usb_bulk.o \
      usb_drv/usb_control.o \
      usb_drv/usb_drv.o \
      usb_drv/usb_request.o \
      usb_drv/usb_usb.o \
      
# macro definitions for library files
OBJLDS= $(TOOL_DIR)/lib/24bit/libstdio.a \
        $(TOOL_DIR)/lib/24bit/libc.a \
        $(TOOL_DIR)/lib/24bit/libgcc.a \
        $(TOOL_DIR)/lib/24bit/libc.a \
        
# macro definitions for assembly files generated from c source files
CEXTTEMPS= boot.ext0 \
      classrequest.ext0 \
      descriptor.ext0 \
      inthdlr.ext0 \
      main.ext0 \
      vector.ext0 \
      vendorclass.ext0 \
      extflsc_drv/extflsc_drv.ext0 \
      flashc_drv/flashc_drv.ext0 \
      usb_drv/usb_bulk.ext0 \
      usb_drv/usb_control.ext0 \
      usb_drv/usb_drv.ext0 \
      usb_drv/usb_request.ext0 \
      usb_drv/usb_usb.ext0 \
      

# macro definitions for original assembly files
ASMEXTTEMPS=                                                                                     

# macro definitions for dependency files
DEPS= $(OBJS:%.o=%.d)
SED_PTN= 's/[[:space:]]\([a-zA-Z]\)\:/ \/cygdrive\/\1/g'
SED_PTN2= 's/^\($(subst .,\.,$(@F))\)\:/$(subst /,\/,$(@))\:/g'

# macro definitions for creating dependency files
DEPCMD_CC= @$(CC_KFILT) -M -MG $(CFLAGS) $< | $(SED) -e $(SED_PTN) | $(SED) -e $(SED_PTN2) >$(@:%.o=%.d)
DEPCMD_AS= @$(AS) -M -MG $(ASFLAGS) $< | $(SED) -e $(SED_PTN) | $(SED) -e $(SED_PTN2) >$(@:%.o=%.d)

# targets and dependencies
.PHONY : all clean

all : $(TARGET).elf

$(TARGET).elf : $(OBJS) usb_rewriter_gnu17IDE.mak usb_rewriter_gnu17IDE.lds
# 1pass linking
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 2>lderr 
	@if [ -s lderr ]; then \
		cmd /c "type lderr" \
		&& $(RM) -f $(TARGET).elf \
		&& exit 1; \
	else $(RM) -f lderr ; \
	fi
	$(OBJDUMP) $(OBJDUMPFLAGS) $@ > $(TARGET).dump 
	$(RM) -f $(TARGET).elf 
# save 1pass object files
	@if [ -e obj1pass ]; then \
		cmd /c "rd /s /q obj1pass" ; \
	fi
	cmd /c "md obj1pass"
	-cmd /c "md obj1pass\extflsc_drv"
	-cmd /c "md obj1pass\flashc_drv"
	-cmd /c "md obj1pass\header"
	-cmd /c "md obj1pass\usb_drv"
	for NAME in $(OBJS) ; do \
		$(CP) -pf $$NAME obj1pass/$$NAME ; done \
	&& $(RM) -f $(OBJS)
# 2pass for assembly files
	for NAME in $(basename $(ASMEXTTEMPS))  ; do \
		$(AS) $(ASFLAGS) $(EXTFLAGS) -o $$NAME.o $$NAME.s ; done
# 2pass for c files
	for NAME in $(basename $(CEXTTEMPS))  ; do \
		$(AS_CC) $(ASFLAGS_CC) $(EXTFLAGS_CC) -o $$NAME.o $$NAME.ext0 ; done
	$(RM) -f $(TARGET).map 
# 2pass linking
	$(LD) $(LDFLAGS) -o $@ $(OBJS) $(OBJLDS) 
# restore 1pass object files
	$(RM) -f $(OBJS) \
	&& \
	for NAME in $(OBJS) ; do \
		$(CP) -pf obj1pass/$$NAME $$NAME ; done \
	&& cmd /c "rd /s /q obj1pass"

## boot.c
boot.o : boot.c boot.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## classrequest.c
classrequest.o : classrequest.c classrequest.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## descriptor.c
descriptor.o : descriptor.c descriptor.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## inthdlr.c
inthdlr.o : inthdlr.c inthdlr.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## main.c
main.o : main.c main.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## vector.c
vector.o : vector.c vector.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## vendorclass.c
vendorclass.o : vendorclass.c vendorclass.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## extflsc_drv/extflsc_drv.c
extflsc_drv/extflsc_drv.o : extflsc_drv/extflsc_drv.c extflsc_drv/extflsc_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## flashc_drv/flashc_drv.c
flashc_drv/flashc_drv.o : flashc_drv/flashc_drv.c flashc_drv/flashc_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## usb_drv/usb_bulk.c
usb_drv/usb_bulk.o : usb_drv/usb_bulk.c usb_drv/usb_bulk.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## usb_drv/usb_control.c
usb_drv/usb_control.o : usb_drv/usb_control.c usb_drv/usb_control.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## usb_drv/usb_drv.c
usb_drv/usb_drv.o : usb_drv/usb_drv.c usb_drv/usb_drv.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## usb_drv/usb_request.c
usb_drv/usb_request.o : usb_drv/usb_request.c usb_drv/usb_request.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)

## usb_drv/usb_usb.c
usb_drv/usb_usb.o : usb_drv/usb_usb.c usb_drv/usb_usb.ext0
	$(CC_KFILT) $(CFLAGS) -o $(@:%.o=%.ext0) $<
	$(AS_CC) $(ASFLAGS_CC) -o $@ $(@:%.o=%.ext0) 
	$(DEPCMD_CC)


# dependecies for assembled c source files
$(CEXTTEMPS) : $(CEXTTEMPS:%.ext0=%.c)

# include dependency files
-include $(DEPS)

# clean files
clean :
	$(RM) -f $(OBJS) $(TARGET).elf $(TARGET).map $(DEPS) $(CEXTTEMPS) $(TARGET).dump lderr 
	@if [ -e obj1pass ]; then \
		cmd /c "rd /s /q obj1pass" ; \
	fi
