/***************************************************************************
*
*	File name : vector.c
*	Function  : Vector Table (C17801)
*	Revision  :
*		07/31/2007	Nariai		First revision
*
****************************************************************************/


// Include File
#include	"vector.h"

// Special definitions for vector table
typedef void func(void);
#ifdef __POINTER16
#define VECTOR(vec)  vec,0
#else
#define VECTOR(vec)  vec
#endif

// Vector Table
func *const vector[] = {		// No	Base+	Name
	/* ----- Non-Maskable Interrupts ----- */
	VECTOR( Boot ),				// 0	00		Reset
	VECTOR( AddrErrInt ),		// 1	04		Address misaligned
	VECTOR( NmiInt ),			// 2	08		NMI
	VECTOR( RsvInt ),			// 3	0C		Reserved

	/* ----- Maskable Interrupts ----- */
	VECTOR( RsvInt ),			// 4	10		Port input interrupt 0
	VECTOR( RsvInt ),			// 5	14		Port input interrupt 1
	VECTOR( RsvInt ),			// 6	18		Port input interrupt 2
	VECTOR( RsvInt ),			// 7	1C		Port input interrupt 3
	VECTOR( RsvInt ),			// 8	20		16-bit MFT Ch.0
	VECTOR( RsvInt ),			// 9	24		Reserved
	VECTOR( RsvInt ),			// 10	28		A/D Converter (Result out of range)
	VECTOR( RsvInt ),			// 11	2C		A/D Converter (End of conversion)
	VECTOR( RsvInt ),			// 12	30		C17_SoC 16-bit Timer Ch.0 interrupt or Port input interrupt 4
	VECTOR( RsvInt ),			// 13	34		C17_SoC  8-bit Timer Ch.1 interrupt or Port input interrupt 5
	VECTOR( RsvInt ),			// 14	38		C17_SoC  8-bit Timer Ch.2 interrupt or Port input interrupt 6
	VECTOR( RsvInt ),			// 15	3C		C17_SoC 16-bit Timer Ch.3 interrupt or Port input interrupt 7
	VECTOR( RsvInt ),			// 16	40		C17_SoC UART Ch.0 interrupt or Port input interrupt 4
	VECTOR( RsvInt ),			// 17	44		C17_SoC UART Ch.0 interrupt or Port input interrupt 5
	VECTOR( RsvInt ),			// 18	48		C17_SoC SPI interrupt or Port input interrupt 6
	VECTOR( RsvInt ),			// 19	4C		C17_SoC I2C interrupt or Port input interrupt 7
	VECTOR( RsvInt ),			// 20	50		RTC
	VECTOR( RsvInt ),			// 21	54		8-bit timer 0
	VECTOR( RsvInt ),			// 22	58		8-bit timer 1
	VECTOR( RsvInt ),			// 23	5C		8-bit timer 2
	VECTOR( RsvInt ),			// 24	60		8-bit timer 3
	VECTOR( RsvInt ),			// 25	64		LCDC interrupt
	VECTOR( RsvInt ),			// 26	68		SPI Ch.1 interrupt
	VECTOR( UsbInt ),			// 27	6C		USB function controller
	VECTOR( RsvInt ),			// 28	70		I2S interrupt (FIFO empty)
	VECTOR( RsvInt ),			// 29	74		I2S interrupt (FIFO full)
	VECTOR( RsvInt ),			// 30	78		REMC interrupt
	VECTOR( RsvInt ),			// 31	7C		Reserved

};

